/*
 * Copyright (c) 1998-2005 Jitterbit, Inc.
 *
 */
package org.jitterbit.util.collections;

import java.util.HashMap;
import java.util.Map;

/**
 * This class build a tree to specify the parent child relationship by
 * simply adding relations in any order
 * optionally an object specified class parameter <T> can be stored
 * with the child. 
 * The top of the tree can be retrieved by getRoot()
 * 
 * @author frank
 *
 * @param <T>
 */
public class BuildTree<T> {
	Map<String,TreeItem<T>> m_map;
	TreeItem<T> m_root;
	
	public BuildTree(){
		m_root=new TreeItem<T>("_ROOT_");
		m_map=new HashMap<String,TreeItem<T>>();
	}
	
	public TreeItem<T> getRoot(){
		return m_root;
	}
	
	public TreeItem<T> addRelation(String sParent, String sChild){
		TreeItem<T> parent=m_map.get(sParent),child=null;
//		System.out.println("parent:m_map.get("+sParent+")="+parent);
		if(parent==null){
			parent=new TreeItem<T>(sParent);
//			System.out.println("new parent="+sParent+","+parent);
			m_map.put(sParent,parent);
			m_root.addChild(parent);
		}
		if(sChild!=null&&sChild.length()>0){
			child=m_map.get(sChild);
//			System.out.println("child:m_map.get("+sChild+")="+child);
			if(child==null){
				child=new TreeItem<T>(sChild);
//				System.out.println("new child="+sChild+","+child);
				m_map.put(sChild,child);
				parent.addChild(child);
			} else {
				if(parent.hasChild(child)==false)
					parent.addChild(child);
				if(m_root.hasChild(child)){
					m_root.removeChild(child);
//					print("remove from m_root, child="+sChild+","+child);
				}
			}
		}
//		print("after insert relation=("+sParent+","+sChild+")");
		return child;
	}
	
	public void print(String sTitle){
		if(m_root==null){
			System.out.println("nothing in the tree");
			return;
		}
		System.out.println(sTitle);
		System.out.println("BuildTree:");
		m_root.print("");
	}
	
}
