/*
 * Copyright (c) 1998-2006 Jitterbit, Inc.
 *
 */
package org.jitterbit.util.lang;

import java.io.File;

/**
 * 
 * @author Torgil
 *
 */
public final class KongaSystemUtils {

    private KongaSystemUtils() {
        throw new UnsupportedOperationException();
    }

    /**
     * <tt>true</tt> iff the application is running on Java version 1.6.
     */
    public static final boolean IS_JAVA_1_6 = JavaVersion.INSTANCE.is_1_6();

    /**
     * The current user's home directory.
     */
    public static final File USER_HOME = new File(System.getProperty("user.home", ""));
    
    
    private static class JavaVersion {
        
        private static final JavaVersion    INSTANCE = new JavaVersion();
        
        private String  m_version = System.getProperty("java.version");
        
        private JavaVersion() {
            m_version = System.getProperty("java.version");
            if (m_version == null) {
                m_version = "";
            }
        }
        
        public boolean is_1_6() {
            return m_version.startsWith("1.6");
        }
    }
    
}
